#!/usr/bin/python
#coding=utf-8
import Tkinter as tk
from random import randint
import tkMessageBox, sys, string, hashlib, crypt

#wrappers for event binding
def showChecksumOnSelect(*args):
    global inputField
    global outputText

    if inputField.get().strip() != "": 
        showChecksum()
    elif outputText.get().strip() != "":
        showChecksum()  
        
def showChecksumOnEnter(event):
    showChecksum()

#defining callback function
def showChecksum():
    global optionList
    global inputField
    global selectValue
    global outputText
    
    """ Display the Entry text value. """
    
    if inputField.get().strip() == "":
        tkMessageBox.showerror("Checksum-Calculator", "Enter a text value for password")
    else:     
        error = 0   
        if selectValue.get() == optionList[0]:
            hash = hashlib.md5(inputField.get().strip()) 
            checksum = hash.hexdigest()            
        elif selectValue.get() == optionList[1]:
            hash = hashlib.sha1(inputField.get().strip()) 
            checksum = hash.hexdigest()
        elif selectValue.get() == optionList[2]:
            saltingChars = './' + string.ascii_letters + string.digits
            max = len(string.ascii_letters) + len(string.digits) + 2 - 1 #64 characters - 1 for index adaption that starts with 0
            salt =  saltingChars[randint(0, 63)] + saltingChars[randint(0, 63)]
            #print('SALT: ' + salt)
            checksum = crypt.crypt(inputField.get().strip(), salt)
        else:
            error = 1
            tkMessageBox.showerror("Checksum-Calculator", "Enter a text value for password")
            
        if error == 0 and checksum:
            #print(checksum)   
            outputText.set(checksum)
            #tkMessageBox.showinfo("Checksum-Calculator", selectValue.get() + " Checksum: " + checksum)            
            
        
        
if __name__ == '__main__':
    
    #defining the main Window
    rootWindow = tk.Tk()
    rootWindow.title("Checksum-Calculation")    
    rootWindow['padx'] = 20
    rootWindow['pady'] = 40    
    
    #label for selectbox
    inputLabel = tk.Label(rootWindow)
    inputLabel['text'] = "Methode wählen: "
    inputLabel.grid(row=0, column=0)
    #inputLabel.pack()
    
    #define selectbox 
    optionList = ('md5', 'sha1', 'crypt')
    selectValue = tk.StringVar() #stringvariable for default
    selectValue.set(optionList[0])
    selectValue.trace('w', showChecksumOnSelect)
    inputField = tk.OptionMenu(rootWindow, selectValue, *optionList)
    inputField['width'] = 50
    inputField.grid(row=0, column=1)
    
    # label for input field
    inputLabel = tk.Label(rootWindow)
    inputLabel['text'] = "Password eingebebn: "    
    inputLabel.grid(row=1, column=0)
    
    #define input field for Password to encrypt
    inputField = tk.Entry(rootWindow)
    inputField['width'] = 50
    inputField['show']='*'
    inputField.bind("<Return>", showChecksumOnEnter)
    inputField.grid(row=1, column=1)
    
    #label for output field
    outputLabel = tk.Label(rootWindow)
    outputLabel['text'] = "Checksum: "
    outputLabel.grid(row=2, column=0)
    
    #define readonly output field 
    outputText = tk.StringVar()
    outputField = tk.Entry(rootWindow, textvariable=outputText)
    outputField['width'] = 50
    outputField['state'] = 'readonly'
    outputField.grid(row=2, column=1)
    
    #define submit button
    button = tk.Button(rootWindow, text="Calculate Checksum", command=showChecksum)
    button.grid(row=3, column=0, columnspan=2)

    rootWindow.mainloop()